<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 * Based on original Pragmamx Modul Reviews modified to Better_Reviews by lenzen24
 */

defined('mxMainFileLoaded') or die('access denied');

function revImageBrowse($cover = '')
{
    if (!mxGetAdminPref('radminreviews')) {
        return '';
    }

    global $revimagepath;
    $displayimage = ($cover) ? $revimagepath . $cover : PMX_IMAGE_PATH . 'noimg.png';
    $key = rand();

    $fb = load_class('Filebrowse');
    if ($fb->is_active()) {
        $fb->set_getback('name');
        $fb->set_root($revimagepath, _COVERIMAGE);
        $fb->set_type('images');
        $fb->dialog();
    }

    ob_start();

    ?>

<input type="text" name="cover" id="coverfield<?php echo $key ?>" value="<?php echo $cover ?>" size="35" maxlength="255" /> &nbsp;

<?php if($fb->is_active()){ ?>
<button id="rtvkhs<?php echo $key ?>"><?php echo _BROWSE ?></button> &nbsp;
<?php } //endif ?>

<img align="top" alt="cover" id="topicimagepic<?php echo $key ?>" src="<?php echo $displayimage ?>" style="max-height:100px;max-width:100px;" />

<script type="text/javascript">
  /*<![CDATA[*/

  $('#rtvkhs<?php echo $key ?>').click(function() {
    pmxfilemanager('coverfield<?php echo $key ?>', true);
    return false;
  });

  $('#coverfield<?php echo $key ?>').change(function() {
    $('#topicimagepic<?php echo $key ?>').attr('src','<?php echo $revimagepath ?>' + this.value);
  });

  /*]]>*/
</script>

    <?php
    $ret = ob_get_clean();
    return $ret;
}

function revAllowedHtml()
{
    return '<span class="tiny">&lt;' . implode('&gt; &lt;', mxGetAllowedHtml()) . '&gt;</span>';
}

?>